import { CacheType, ChatInputCommandInteraction, Message, PermissionFlagsBits, SlashCommandBuilder } from 'discord.js';
import ConfigManager from '../controller/ConfigManager';
import EcoManager from '../controller/EcoManager';


// const adminPermissions = new PermissionsBitField('Administrator');

export default {
  data: new SlashCommandBuilder()
    .setName('alert')
    .setDescription('Alert to game')
    .addStringOption(opt => opt.setName("message").setDescription("Alert message").setRequired(true))
    .setDefaultMemberPermissions(PermissionFlagsBits.Administrator),
  async execute(interaction: ChatInputCommandInteraction<CacheType>, config: ConfigManager) {
    const ecoManager = new EcoManager(config)

    const message = interaction.options.getString('message')

    await interaction.deferReply({ ephemeral: true })

    try {
      await interaction.followUp(`Отправка уведомления`);

      if (!message) {
        await interaction.editReply(`Ошибка отправки уведомления`);
        return
      }

      const status = await ecoManager.Alert(message)
      if (!!status && !status.Errored) {
        await interaction.editReply("Уведомление отправлено")
      } else {
        await interaction.editReply("Ошибка отправки уведомления")
      }
      return
    } catch (error) {
      await interaction.editReply("Ошибка отправки уведомления")
      console.log(error)
    }
  },
};
