import path from "path";
import fs from "fs";
import UserI from "../types/UserI";

export default class ConfigManager {
  configPath = path.join(process.env.STORAGE || "/app/storage", "config.json")
  public guildId: string | null | undefined = null
  public userManager: {
    users: UserI[];
    discord: String[];
    authCodes: Date[];
  } = {
      users: [],
      discord: [],
      authCodes: [],
    }

  constructor() {
    this.load()
    setInterval(() => this.save(), 10000)
  }
  save() {
    const r = { userManager: this.userManager, guildId: this.guildId }
    fs.writeFileSync(this.configPath, JSON.stringify(r))
  }
  load() {
    const r = { userManager: this.userManager, guildId: this.guildId }
    if (!fs.existsSync(this.configPath)) {
      fs.writeFileSync(this.configPath, JSON.stringify(r))
    }
    try {
      const t: ConfigManager = JSON.parse(String(fs.readFileSync(this.configPath)))
      if (!!t?.guildId)
        this.guildId = t.guildId
      if (!!t?.userManager)
        this.userManager = { ...this.userManager, ...t.userManager }
    } catch (error) {
      console.log(error)
    }
  }
}