import { ActionRowBuilder, ButtonBuilder, ButtonStyle, CacheType, ChatInputCommandInteraction, Message } from "discord.js";
import ConfigManager from "./ConfigManager";
import axios from "axios";
import UserI from "../types/UserI";

export default class UserManager {
  config: ConfigManager
  public constructor(config: ConfigManager) {
    this.config = config
  }
  public async sync() {
    try {
      const { data, status } = await axios.get<UserI[]>(`${process.env.ECO_API_BASE || "https://eco.kamgames.xyz"}/api/v1/users`, {
        timeout: 5000,
        headers: {
          "X-API-Key": process.env.ECO_API_KEY
        }
      });

      if (status !== 200) return false

      this.config.userManager.users = data

      return true
    } catch (error) {
      console.log(error)
    }
    return false
  }
}